@echo off
echo C.BAT Lazy changing of directory, Fri 20-May-2005
echo By Prof. Timo Salmi, ts@uwasa.fi, (c) 1992-2005
echo.

rem If you are fed up with typing \ in changing the directory
rem with the cd command, this is the batch for you
rem I have regularly used this convenient batch for over a decade

rem E.g. if you have a directory \text\jokes\stupid the just use
rem c text jokes stupid
rem Applying c without parameters takes you to the root directory
rem Drive can be an optional first parameter, e.g. c d: text jokes stupid

rem Applicable all through MS-DOS+Win../95/98/Me and NT/2000/XP
rem However, directory names with spaces are not supported

:: Where to put the history
::
set temp_=%temp%
if not [%mytemp%]==[] set temp_=%mytemp%
set dirhist_=%temp_%\dirhist.txt
if not [%OS%]==[Windows_NT] if exist l:\temp\nul set dirhist_=l:\temp\dirhist.txt
if [%OS%]==[Windows_NT] if exist c:\_l\temp set dirhist_=c:\_l\temp\dirhist.txt

:: Show usage if asked
::
if [%1]==[?] goto _usage
if [%1]==[/?] goto _usage

:: Show history if asked
::
for %%p in (h H hist HIST) do if [%1]==[/%%p] goto _hist

:: Set the drive if relevant
::
set drive_=
for %%d in (a b c d e f g h i j k l m n o p q r s t u v x y z) do if [%1]==[%%d:] set drive_=%%d:
if [%drive_%]==[] goto _set_dir

:: Change to the asked drive if exists
::
if not [%OS%]==[Windows_NT] if not exist %drive_%\nul goto _err_driv
if [%OS%]==[Windows_NT] if not exist %drive_%\ goto _err_driv
echo Changing drive to %drive_%
%drive_%
shift

:: Build the directory path
::
:_set_dir
set dir_=
:_loop
set dir_=%dir_%\%1
shift
if not [%1]==[] goto _loop

if not [%dir_%]==[\] if not exist %dir_%\nul goto _err_dir

:: Change to to indicated directory
::
echo Changing directory to %dir_%
rem Initial directory to the history
if not exist %dirhist_% cd>>%dirhist_%
rem Actually change the directory
cd %dir_%
rem Store the new location
cd>>%dirhist_%
goto _out

:_hist
type %dirhist_%
goto _out

:_err_driv
echo Drive %drive_% does not exist
goto _out

:_err_dir
echo Directory %dir_% does not exist
goto _out

:_usage
echo Usage: C [Drive:] [dir] [subdir] [subsubdir]
echo.
echo For the main directory ("root"): C
echo.
echo C [/H[IST]] to show the directories history
goto _out

:_out
for %%v in (backdir_ drive_ dir_ temp_) do set %%v=
if "%USERNAME%"=="ts" if not "%dosbox%"=="true" if not "%cmdbox%"=="true" pause
if "%USERNAME%"=="es" if not "%dosbox%"=="true" if not "%cmdbox%"=="true" pause
